import swarm.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import swarm.Selector;
import swarm.space.*;
import swarm.collections.*;
import java.io.*;
//f̒`
public class ModelSwarm extends SwarmImpl{

  public int worldXSize, worldYSize;
  public int slimeCellSum;
  public int stepCounter;
  public int randomSeed;
  public int distributeLeftMost;
  public int distributeRightMost;
  public int slimeVision;
  RandomMaze maze;
  
  Grid2d world;

  List slimeCellList;
  ActionGroup modelActions;
  Schedule modelSchedule;

  public ModelSwarm(Zone aZone){

    super(aZone);

    randomSeed = 1;

    worldXSize = 132;
    worldYSize = 132;
    slimeVision = 5;
    slimeCellSum = 2000;
    
    EmptyProbeMap probeMap;
    probeMap = new EmptyProbeMapImpl(aZone,this.getClass());
    distributeLeftMost = 5;
    distributeRightMost = worldXSize-10;
      
    probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
    ("randomSeed",getClass()));
    probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
    ("slimeCellSum",getClass()));
    probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
    ("distributeLeftMost",getClass()));
    probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
    ("distributeRightMost",getClass()));
    probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
    ("worldXSize",getClass()));
    probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
    ("worldYSize",getClass()));
    probeMap.addProbe(Globals.env.probeLibrary.getProbeForVariable$inClass
    ("slimeVision",getClass()));
    

//    ("initializeFood",getClass()));

    Globals.env.probeLibrary.setProbeMap$For(probeMap,this.getClass());

  }

  public Object buildObjects(){

  	SlimeCell aSlime;

    maze = new RandomMaze(this,worldXSize,worldYSize);
    initializeMaze();

    world=new Grid2dImpl(this,worldXSize,worldYSize);
    world.fillWithObject(null);

    // Now, create a bunch of slimes to live in the world
    slimeCellList=new ListImpl(this);

    for (int x = 0; x < slimeCellSum; x++){
        aSlime = new SlimeCell(this);
        aSlime.setWorld$Maze(world,maze); //add
        aSlime.setSlimeCellParametar(slimeVision);  	    aSlime.setX$Y(Globals.env.uniformIntRand.getIntegerWithMin$withMax(distributeLeftMost,distributeRightMost) ,Globals.env.uniformIntRand.getIntegerWithMin$withMax(distributeLeftMost,distributeRightMost));
        slimeCellList.addLast(aSlime);
    }


  Globals.env.randomGenerator.setStateFromSeed(randomSeed);

  output();

  return this;

  }

  public Object buildActions(){

    // Create the list of simulation actions.

    modelActions=new ActionGroupImpl(this);
    try{
      modelActions.createActionTo$message(maze,new Selector(Class.forName("RandomMaze"),"step",false));
      modelActions.createActionForEach$message(slimeCellList,
       new Selector(Class.forName("SlimeCell"),"step",false));
    } catch (Exception e) {
      e.printStackTrace (System.err);
      System.exit(1);
    }

    modelSchedule=new ScheduleImpl(this,1);
    modelSchedule.at$createAction(0,modelActions);    
    
    return this;
  }

  public Activity activateIn(Swarm context){

    super.activateIn (context);
    modelSchedule.activateIn(this);
    return getActivity();
  }

  public Grid2d getWorld(){
    return world;
  }    
  public RandomMaze getMaze(){
    return maze;
  }
  
  public List getSlimeCellList(){
    return slimeCellList;
  }

  public void initializeMaze(){
    maze.setFoodParams(8,8,4,119,119,4);
    maze.giveMaze(); 
  }

  public void output(){

  FileWriter fw;
  try{
    fw = new FileWriter("environment.txt");
  } catch (IOException e) {
    System.out.println("write File can not open");
    fw = null;
  }

  try{

    PrintWriter out = new PrintWriter(fw);

    out.print(worldXSize + " ");
    out.print(worldYSize + " ");
    out.print(slimeCellSum + " ");

    //out.print(randomSeed + " ");

    fw.close();

    } catch (Exception e) {}

  }

}


