import swarm.simtoolsgui.*;
import swarm.gui.*;
import swarm.simtoolsgui.*;
import swarm.space.*;
import swarm.activity.*;
import swarm.defobj.*;
import swarm.objectbase.*;
import swarm.*;

//r[̒`
public class ObserverSwarm extends GUISwarmImpl{
  int displayFrequency; // one parameter: update freq

  ActionGroup displayActions; 
  Schedule displaySchedule;

  ModelSwarm modelSwarm; // the Swarm we're observing


  Colormap colorMap; // allocate colours
  Colormap colorFood;
  ZoomRaster worldRaster; // 2d display widget


  Object2dDisplay slimeCellDisplay; // display the slim cell
  Value2dDisplay randomMazeDisplay;    
  public ObserverSwarm(Zone aZone){
    // Superclass createBegin to allocate ourselves.
    super(aZone);

    // Fill in the relevant parameters (only one, in this case).
    displayFrequency=1;
  }

  public Object buildObjects(){
    super.buildObjects();
    //modelSwarm = new ModelSwarm();
    modelSwarm = (ModelSwarm)    Globals.env.lispAppArchiver.getWithZone$key(Globals.env.globalZone,"modelSwarm"); //G[ꍇ͖̎̏

    Globals.env.createArchivedProbeDisplay (modelSwarm,"modelSwarm");	
    getControlPanel().setStateStopped();

    modelSwarm.buildObjects();

    colorMap=new ColormapImpl(this);
    colorMap.setColor$ToName((byte)1,"white"); //LXgKv
    colorMap.setColor$ToName((byte)0,"black");
    colorMap.setColor$ToName((byte)2,"red");
    colorMap.setColor$ToName((byte)3,"yellow");
    colorMap.setColor$ToName((byte)4,"orange");
    for ( int k = 0; k < 243; k++ ){
      colorMap.setColor$ToRed$Green$Blue
      ((byte)(11+k), (242+k)/484.0, (242+k)/484.0, (242+k)/484.0);
    }	

  worldRaster=new ZoomRasterImpl(this);
  worldRaster.setColormap(colorMap);
  worldRaster.setZoomFactor(4);
  worldRaster.setWidth$Height(
  modelSwarm.getWorld().getSizeX(),
  modelSwarm.getWorld().getSizeY());
  worldRaster.setWindowTitle("Slime Maze");
  worldRaster.pack();

  randomMazeDisplay=new Value2dDisplayImpl(this,worldRaster,colorMap,modelSwarm.getMaze());    
  
  try {
     slimeCellDisplay = new Object2dDisplayImpl(this,
     worldRaster,
     modelSwarm.getWorld(),
     new Selector(Class.forName("SlimeCell"), "drawSelfOn", false));
  } catch (Exception e) {
    System.exit(1);
  }
  slimeCellDisplay.setObjectCollection(modelSwarm.getSlimeCellList());
    return this;
  }

  public Object buildActions(){

    // First, let our model swarm build its own schedule.
    modelSwarm.buildActions();

    displayActions=new ActionGroupImpl(this);
    // Schedule up the methods to draw the display of the world

    try {
      displayActions.createActionTo$message(slimeCellDisplay,
      new Selector(slimeCellDisplay.getClass(),"display",false));
      

      displayActions.createActionTo$message(randomMazeDisplay,
       new Selector(randomMazeDisplay.getClass(),"display",false));

      displayActions.createActionTo$message(worldRaster,
      new Selector(worldRaster.getClass(),"drawSelf",false));
      displayActions.createActionTo$message(getActionCache(),
      new Selector(getActionCache().getClass(),"doTkEvents",true));
    } catch (Exception e) {
      System.out.println ("Exception: " + e.getMessage ());
      System.exit(1);
    }
    displaySchedule = new ScheduleImpl(this,displayFrequency);
    displaySchedule.at$createAction(0,displayActions);

    return this;
  }

  public Activity activateIn(Swarm context){
    super.activateIn(context);


    modelSwarm.activateIn(this);

    displaySchedule.activateIn(this);

    return getActivity();
  }
}
