import swarm.*;
import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;
import swarm.activity.*;
import swarm.Selector;
import swarm.collections.*;
import java.util.*;
//$B3FG46]:YK&$N5sF0$NDj5A(B
public class SlimeCell extends SwarmObjectImpl {
  int drainX, drainY, volume, rhythm, width; //
  int xPos, yPos;
  int vision;
  int worldXSize, worldYSize;
  ArrayList<Vector<Integer>> lookVecs;
  RandomMaze maze;
  Grid2d world;

  public SlimeCell(Zone aZone){
    super(aZone);
    vision = 5;
    //$B8+2s$7%Y%/%H%k$r=i4|2=(B
    lookVecs = new ArrayList<Vector<Integer>>();
    lookVecs.add(getVec(0,1));
    lookVecs.add(getVec(0,-1));
    lookVecs.add(getVec(1,0));    
    lookVecs.add(getVec(-1,0));
  }
  

  public Object setWorld$Maze(Grid2d w,RandomMaze m){
    world = w;
    maze=m;
    worldXSize = world.getSizeX();
    worldYSize = world.getSizeY();
    return this;
  }

  public void setSlimeCellParametar(int i_vision){
    vision = i_vision;
  }


  public Object setX$Y(int x, int y){
    xPos = x;
    yPos = y;
    if(maze.getValueAtX$Y(xPos,yPos) == 0){
      maze.putValue$atX$Y(3,xPos,yPos);
      return this;
    }
    //world.putObject$atX$Y(this,xPos,yPos);
    return null;
  }

  public Object setWorldSizeX$Y(int xSize, int ySize){
    worldXSize=xSize;
    worldYSize=ySize;
    return this;
  }

//$B3F<B9T%9%F%C%W$NDj5A(B
public void step(){

    int newX,newY,sX,sY,xDef=0,yDef=0,i,j,k,dir;
    boolean exitFlag,findFlag;
    //$BJI$+1B$KKd$^$C$F$$$k>l9g$O2?$b$7$J$$(B    
    if((maze.getValueAtX$Y(xPos,yPos) == 1) || (maze.getValueAtX$Y(xPos,yPos) == 2)) return;

    Collections.shuffle(lookVecs);
    findFlag = false;
    for(dir=0;dir<lookVecs.size();dir++){
      xDef = lookVecs.get(dir).get(0);
      yDef = lookVecs.get(dir).get(1);
      exitFlag=false;
      for(i = 1; i < vision; i++){
        for (j = 1; j < vision; j ++){
          sX = xPos + xDef * i;
          sY = yPos + yDef * j;
          if(maze.getValueAtX$Y(sX,sY)==1){
            exitFlag = true;
            break;
          }
          
          if(maze.getValueAtX$Y(sX,sY)==2 || maze.getValueAtX$Y(sX,sY)==4){
            findFlag = true;
            exitFlag = true;
            break;
          } 
          
        }
        if(exitFlag) break;
      }
      if (findFlag) break;
    }
    //find neutrish or feeded cell
    if (findFlag){
      newX = xPos + xDef;
      newY= yPos + yDef;
      if(maze.getValueAtX$Y(newX,newY) == 0){
        maze.putValue$atX$Y(0,xPos,yPos);
        maze.putValue$atX$Y(3,xPos=newX,yPos=newY);
      }else if(maze.getValueAtX$Y(newX,newY) == 2 || maze.getValueAtX$Y(newX,newY) == 4){
        maze.putValue$atX$Y(4,xPos,yPos);
      }
    }else{
     
      //if couldn't find one of them, move 1 block at random 
      moveRandom();
    }
  }
  
  private void moveRandom(){
    int newX,newY;
    
    newX = Globals.env.uniformIntRand.getIntegerWithMin$withMax(xPos - 1,xPos + 1);
    newY= Globals.env.uniformIntRand.getIntegerWithMin$withMax(yPos - 1,yPos + 1);
    if(maze.getValueAtX$Y(newX,newY) == 0){
      maze.putValue$atX$Y(0,xPos,yPos);
      maze.putValue$atX$Y(3,xPos=newX,yPos=newY);
    }
  } 

  public Object drawSelfOn(Raster r){
    r.drawPointX$Y$Color(xPos,yPos,(byte)3);

    return this;
  }
  private static Vector<Integer> getVec(int x,int y){
    Vector<Integer> v = new Vector<Integer>();
    v.add(x);
    v.add(y);
    return v;
  }
    
}












